package com.mann.jump;

import java.util.Random;

import com.mann.dstarlite.GridProblem;

public class Tester {
	
	public static final int chance = 5;
	public static final Random random = new Random();
	
	public static void randomizeGrid(JumpPointGrid grid, GridProblem gp) {
		for(int i = 0; i < grid.getLength(); i++) {
			for(int j = 0; j < grid.getHeight(); j++) {
				if(random.nextInt(chance) == 0){
					grid.setWall(i, j);
					gp.setWall(i, j);
				}
			}
		}
		boolean found = false;
		while(!found) {
			int curX = random.nextInt(grid.getLength());
			int curY = random.nextInt(grid.getHeight());
			if(!grid.isWall(curX, curY)) {
				gp.setGoal(curX, curY);
				grid.setGoal(curX, curY);
				found = true;
			}
		}
		
		found = false;
		while(!found) {
			int curX = random.nextInt(grid.getLength());
			int curY = random.nextInt(grid.getHeight());
			if(!grid.isWall(curX, curY) && !grid.get(curX, curY).equals(grid.getGoal())) {
				found = true;
				grid.setStart(curX, curY);
				gp.setStart(curX, curY);
			}
		}
	}
	
	public static void randomizeGrid(JumpPointGrid grid) {
		for(int i = 0; i < grid.getLength(); i++) {
			for(int j = 0; j < grid.getHeight(); j++) {
				if(random.nextInt(chance) == 0){
					grid.setWall(i, j);
				}
			}
		}
		boolean found = false;
		while(!found) {
			int curX = random.nextInt(grid.getLength());
			int curY = random.nextInt(grid.getHeight());
			if(!grid.isWall(curX, curY)) {
				grid.setGoal(curX, curY);
				found = true;
			}
		}
		
		found = false;
		while(!found) {
			int curX = random.nextInt(grid.getLength());
			int curY = random.nextInt(grid.getHeight());
			if(!grid.isWall(curX, curY) && !grid.get(curX, curY).equals(grid.getGoal())) {
				found = true;
				grid.setStart(curX, curY);
			}
		}
	}
	
	public static void removeWalls(JumpPointGrid grid) {
		for(int i = 0; i < grid.getLength(); i++) {
			for(int j = 0; j < grid.getHeight(); j++) {
				grid.removeWall(i, j);
			}
		}
	}
	
	public static void removeWalls(JumpPointGrid grid, GridProblem gp) {
		for(int i = 0; i < grid.getLength(); i++) {
			for(int j = 0; j < grid.getHeight(); j++) {
				grid.removeWall(i, j);
				gp.removeWall(i, j);
			}
		}
	}
	
	public static void addWall(JumpPointGrid grid, GridProblem gp) {
		boolean found = false;
		while(!found) {
			int curX = random.nextInt(grid.getLength());
			int curY = random.nextInt(grid.getHeight());
			if(!grid.isWall(curX, curY) && !grid.get(curX, curY).equals(grid.getGoal()) &&
					!grid.get(curX, curY).equals(grid.getStart())) {
				found = true;
				grid.setWall(curX, curY);
				gp.setWall(curX, curY);
			}
		}
	}
	
	public static void main(String[] args) {
		final int NUM_RUNS = 1000;
		
		JumpPointGrid grid = new JumpPointGrid(100,100);
		//GridProblem gp = new GridProblem(100,100);
		JumpPoint jumpSolver = new JumpPoint(grid);
		//DStarLite dStarSolver = new DStarLite(gp);
		
		long totalAStarExpansions = 0;
		long totalAStarNeighbors = 0;
		long totalJPSExpansions = 0;
		long totalJPSJumpExpansions = 0;
		int AStarLength = 0;
		int JPSLength = 0;
		//long totalDStarExpansions = 0;
		//int count = NUM_RUNS;
		for(int i = 0; i < NUM_RUNS; i++) {
			Tester.randomizeGrid(grid);
			AStarLength = jumpSolver.AStarSearch().size();
			totalAStarExpansions += jumpSolver.getCellExpansions();
			totalAStarNeighbors += jumpSolver.getJumpExpansions();
			JPSLength = jumpSolver.JPSearch().size();
			totalJPSExpansions += jumpSolver.getCellExpansions();
			totalJPSJumpExpansions += jumpSolver.getJumpExpansions();
			if(JPSLength != AStarLength) {
				System.out.println("Different");
			}
			Tester.removeWalls(grid);
		}
		/*int tempAStar = 0;
		int tempDStar = 0;
		for(int i = 0; i < NUM_RUNS; i++) {
			Tester.randomizeGrid(grid, gp);
			gp.intialize();
			for(int j = 0; j < 2; j++){
				List<State> dPath = dStarSolver.getShortestPath();
				List<JumpPointCell> jPath = jumpSolver.JPSearch();
				if(dPath != null && jPath != null && jPath.size() == dPath.size()) {
					tempAStar += jumpSolver.getCellExpansions();
					grid.reinitializeGrid();
					tempDStar += dStarSolver.getExpandedStates().size();
				} else {
					tempAStar = 0;
					tempDStar = 0;
					count--;
					break;
				}
				Tester.addWall(grid, gp);
			}
			totalDStarExpansions += tempDStar;
			totalJPSExpansions += tempAStar;
			Tester.removeWalls(grid, gp);
		}*/
		totalJPSExpansions /= NUM_RUNS;
		totalAStarExpansions /= NUM_RUNS;
		totalJPSJumpExpansions /= NUM_RUNS;
		totalAStarNeighbors /= NUM_RUNS;
		System.out.println("The chance of a wall is: " + Tester.chance);
		System.out.println("The average number of cell expansions for A* is: " + totalAStarExpansions);
		System.out.println("However the average number of neighbors for A* is:" + totalAStarNeighbors);
		System.out.println("The average number of cell expansions for JPS is:" + totalJPSExpansions);
		System.out.println("However the average number of jump expansions is:" + totalJPSJumpExpansions);
		
		/*totalDStarExpansions /= count;
		System.out.println("The chance of a wall is: " + Tester.chance);
		System.out.println("The average number of cell expansions for JPS is:" + totalJPSExpansions);
		System.out.println("The average number of cell expansions for D* is :" + totalDStarExpansions);*/
	}

}
